#pragma once
#include "resource.h"
#include "launch/launch.h"

#define APP_TITLE	"mini ISD"
#define WM_NOTIFY_ICON	(WM_APP + 100)
#define SC_CONFIG	100
#define SC_ABOUT	101
#define SIG_COPYDATA	"mISD" /* WM_COPYDATÃVOl` */

/****************************************************************************
 *	CDirEntry/CDir
 ****************************************************************************/

class CDirEntry {
public:
	int size;	/* TCY[oCg] */
	CString fname;	/* t@C */
};
typedef CList<CDirEntry, const CDirEntry&> CDirEntryList;

class CDir {
public:
	CDirEntryList list;	/* t@CXg */
	CString info;		/* vTCYs */

	/* t@CXg擾܂B
	 * [out]
	 *	߂l		0ȊO̒lԂ܂B
	 *			s0Ԃ܂B
	 */
	int init();
};

/****************************************************************************
 *	CFileList
 ****************************************************************************/

class CFileList : public CListBox {
public:
	int refresh(CStringList* sel_list = NULL);
	void on_delete();
	void on_pause();
	//{{AFX_VIRTUAL(CFileList)
	protected:
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CFileList)
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnDblclk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/****************************************************************************
 *	CMyDlg
 ****************************************************************************/

class CMyDlg : public CDialog {
public:
	CMyDlg(CWnd* pParent = NULL);
	//{{AFX_DATA(CMyDlg)
	enum { IDD = IDD_MINISD };
	CFileList m_filelist;
	//}}AFX_DATA
	//{{AFX_VIRTUAL(CMyDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual void OnOK();
	//}}AFX_VIRTUAL
protected:
	HICON m_hIcon;
	NOTIFYICONDATA m_nid;
	//{{AFX_MSG(CMyDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnDestroy();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	//}}AFX_MSG
	afx_msg void OnNotifyIcon(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/****************************************************************************
 *	CMyApp
 ****************************************************************************/

class CMyApp : public CWinApp {
public:
	//{{AFX_VIRTUAL(CMyApp)
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CMyApp)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/****************************************************************************
 *	CMyOleDropSource
 ****************************************************************************/

/* hbvOɃ[h邽߂̃tbNB
 * x̐`łɂAxDrag&Dropɂ̂ݎg܂B
 * xȏgƐ삵܂BӁI
 */
class CMyOleDropSource : public COleDropSource {
public:
	CMyOleDropSource();
	virtual ~CMyOleDropSource();
	virtual SCODE QueryContinueDrag(BOOL bEscapePressed, DWORD dwKeyState);
	CStringList fname_list;		/* [ht@CXg */
	/* QueryContinueDrag̒ŃG[_CAO\ƁA
	 * hbOȂ̂Ń}EXLv`ĂāA[OK]ȂȂ܂B
	 * āADoDragDropIɃG[bZ[W\悤ɁA
	 * G[̓bZ[WɊi[Ă܂B
	 */
	CString err_msg;
protected:
	CStringList fname_list_loaded;	/* [ht@CXg */
};

/****************************************************************************
 *	̑
 ****************************************************************************/

int ism_init();
int ism_exit();
int ismAppPause(int pausef);
int ismLCDGetInfo(int* pstat, unsigned long* pbuff);
void write_files(CStringList* fname_list);
void split_cmdline(const char* p, CStringList* list);
void run_pex(const char* fname);
void run_srf(char* data);
void lru_add(const char* fname);
void lru_add();
int lru_ensure();

/****************************************************************************
 *	CCfgDlg
 ****************************************************************************/

class CCfgDlg : public CDialog {
public:
	CCfgDlg(CWnd* pParent = NULL);
	//{{AFX_DATA(CCfgDlg)
	enum { IDD = IDD_CONFIG };
	int m_mode;
	CString m_folder;
	BOOL m_warnoverwr;
	BOOL m_openfolder;
	//}}AFX_DATA
	//{{AFX_VIRTUAL(CCfgDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL
protected:
	//{{AFX_MSG(CCfgDlg)
	afx_msg void OnFolderBrowse();
	afx_msg void OnMode0();
	afx_msg void OnMode1();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	void mode_changed(int mode);
};
